## lomiri-clock-app 3.13~git20221027.60c85a4

=== CMakeLists.txt ===
project(lomiri-clock-app C CXX)
cmake_minimum_required(VERSION 2.8.12)

include(FindPkgConfig)

set (MANIFEST_PATH "manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-permissive -pedantic -Wall -Wextra")

find_package(Qt5Core)
find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5DBus)
#find_package(ubuntu-sdk-libs)

include(FindGettext)
if(NOT GETTEXT_FOUND)
  message(FATAL_ERROR "Could not find gettext")
endif(NOT GETTEXT_FOUND)

#automatically create moc files
set(CMAKE_AUTOMOC ON)

option(INSTALL_TESTS "Install the tests on make install" on)
option(CLICK_MODE "Build as a click package" on)
option(USE_XVFB "Use XVFB to run qml tests" on)

enable_testing()

# Standard install paths
include(GNUInstallDirs)

set(CLICK_NAME              clock.ubports)
set(APP_NAME                clock)
set(APP_HARDCODE            lomiri-clock-app)
set(MAIN_QML                ${APP_HARDCODE}.qml)
set(DESKTOP_FILE            "${APP_HARDCODE}.desktop")
set(ICON_FILE               clock-app.svg)
set(SPLASH_FILE             clock-app-splash.svg)
SET(AUTOPILOT_DIR           lomiri_clock_app)
set(URLS_FILE               "${CLICK_NAME}_${APP_NAME}.url-dispatcher")

#set install paths
if(CLICK_MODE)
  set(CMAKE_INSTALL_PREFIX "/")
  set(LOMIRI-CLOCK_APP_DIR    "${CMAKE_INSTALL_DATADIR}/qml")

  set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}")
  set(MODULE_PATH ${QT_IMPORTS_DIR})
  set(ICON ${ICON_FILE})
    if(NOT SOURCE)
        execute_process(
            COMMAND git remote -v
            COMMAND grep origin
            COMMAND grep push
            COMMAND awk "{print $2}"
            OUTPUT_VARIABLE SOURCE
            RESULT_VARIABLE res
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        message("-- Setting SOURCE to ${SOURCE} with result of : ${res}")
        set(SOURCE lp:${APP_HARDCODE})
        message("-- Setting SOURCE to ${SOURCE}")
    endif(NOT SOURCE)

else(CLICK_MODE)
  set(LOMIRI-CLOCK_APP_DIR "${CMAKE_INSTALL_DATADIR}/${APP_HARDCODE}")
  execute_process(
    COMMAND qmake -query QT_INSTALL_QML
            OUTPUT_VARIABLE QT_IMPORTS_DIR
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  set(MODULE_PATH ${QT_IMPORTS_DIR}/ClockApp)
  set(ICON ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${ICON_FILE})
endif(CLICK_MODE)

if(${CLICK_MODE})
  message("-- Configuring manifest.json")

  execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_ARCH
    OUTPUT_VARIABLE CLICK_ARCH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  configure_file(${MANIFEST_PATH} ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES "${APP_HARDCODE}.json" DESTINATION ${CMAKE_INSTALL_PREFIX})
  set(EXEC "qmlscene -I ${MODULE_PATH} %U ${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
else(CLICK_MODE)
  set(EXEC "qmlscene $@ -I ${MODULE_PATH}  ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
endif()

install(FILES ${URLS_FILE} DESTINATION "${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls")

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)

add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

add_subdirectory(app)
add_subdirectory(backend)
add_subdirectory(po)
#Disabling autopilot tests for now due to CI issues
#add_subdirectory(tests)

# make the README files visible in qtcreator
file(GLOB README_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    README*)

add_custom_target(clock_ubports_READMEFiles SOURCES ${README_FILES})

add_custom_target("autopilot" chmod +x ${CMAKE_SOURCE_DIR}/tests/autopilot/run
                    COMMAND ${CMAKE_SOURCE_DIR}/tests/autopilot/run
                    DEPENDS timezone timezone-qmldir alarmsettings alarmsettings-qmldir datetime datetime-qmldir geolocation geolocation-qmldir
                    WORKING_DIRECTORY ./app)

add_custom_target("run" /usr/bin/qmlscene -I ${CMAKE_BINARY_DIR}/backend  ${CMAKE_SOURCE_DIR}/app/lomiri-clock-app.qml
                    DEPENDS timezone timezone-qmldir alarmsettings alarmsettings-qmldir datetime datetime-qmldir geolocation geolocation-qmldir
                    WORKING_DIRECTORY ./app)

=== tests/CMakeLists.txt ===
add_subdirectory(unit)

if(NOT CLICK_MODE)
  add_subdirectory(autopilot)
endif(NOT CLICK_MODE)

=== tests/unit/CMakeLists.txt ===
find_program(QMLTESTRUNNER_BIN
    NAMES qmltestrunner
    PATHS /usr/lib/*/qt5/bin
    NO_DEFAULT_PATH
)

find_program(XVFB_RUN_BIN
    NAMES xvfb-run
)

macro(DECLARE_QML_TEST TST_NAME TST_QML_FILE)
    if(USE_XVFB AND XVFB_RUN_BIN)
        set(COMMAND_PREFIX ${XVFB_RUN_BIN} -a -s "-screen 0 400x600x24")
    else()
        set(COMMAND_PREFIX "")
    endif()
    add_test(NAME ${TST_NAME}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMAND ${COMMAND_PREFIX} ${QMLTESTRUNNER_BIN} -import ${CMAKE_BINARY_DIR}/backend -input ${CMAKE_CURRENT_SOURCE_DIR}/${TST_QML_FILE}
    )
endmacro()

if(QMLTESTRUNNER_BIN)
    declare_qml_test("AlarmLabel" tst_alarmLabel.qml)
    declare_qml_test("AlarmRepeat" tst_alarmRepeat.qml)
    declare_qml_test("Alarm" tst_alarm.qml)
    declare_qml_test("AlarmSound" tst_alarmSound.qml)
    declare_qml_test("AlarmUtils" tst_alarmUtils.qml)
#    declare_qml_test("WorldClock" tst_worldClock.qml) FIXME: BROKEN!!!
    declare_qml_test("StopwatchUtils" tst_stopwatchUtils.qml)
else()
    if (NOT QMLTESTRUNNER_BIN)
        message(WARNING "Qml tests disabled: qmltestrunner not found")
    else()
        message(WARNING "Qml tests disabled: xvfb-run not found")
    endif()
endif()

set(QML_TST_FILES
    tst_alarmLabel.qml
    tst_alarmRepeat.qml
    tst_alarm.qml
    tst_alarmSound.qml
    tst_alarmUtils.qml
#    tst_worldClock.qml FIXME! BROKEN TEST!!
    tst_stopwatchUtils.qml
)
add_custom_target(tst_QmlFiles ALL SOURCES ${QML_TST_FILES})

set(QML_TST_UTILS
    MockClockApp.qml
    ClockTestCase.qml
)

add_custom_target(tst_Utils ALL SOURCES ${QML_TST_UTILS})

=== debian/changelog ===
lomiri-clock-app (3.13~git20221027.60c85a4-2) unstable; urgency=medium

  * Upload to unstable source-only.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 06 Nov 2022 22:08:05 +0100

lomiri-clock-app (3.13~git20221027.60c85a4-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1023017).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 29 Oct 2022 11:34:21 +0200

=== debian/control ===
Source: lomiri-clock-app
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               intltool,
               python3 | python3-all | python3-dev | python3-all-dev,
               python3-minimal,
               libgeonames-dev,
               lomiri-sounds,
               suru-icon-theme,
               qml-module-qttest,
               qml-module-qtsysteminfo,
               qml-module-qt-labs-settings,
               qml-module-u1db,
               qml-module-qtmultimedia,
               qml-module-qtpositioning,
               qml-module-lomiri-content,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qt-labs-folderlistmodel,
               qml-module-lomiri-components,
               qml-module-lomiri-layouts,
               qml-module-lomiri-test,
               xauth,
               xvfb,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/apps/lomiri-clock-app
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-clock-app.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-clock-app

Package: lomiri-clock-app
Architecture: any
Depends: qmlscene,
         qml-module-u1db,
         qml-module-lomiri-components,
         qml-module-lomiri-layouts,
         qml-module-qtquick-xmllistmodel,
         qml-module-qtmultimedia,
         qml-module-qtpositioning,
         qml-module-lomiri-content,
         lomiri-sounds,
         suru-icon-theme | ubuntu-mobile-icons,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Clock App for Lomiri Operating Environment
 This app is a core app for Ubuntu Touch's shell Lomiri. Ubuntu Touch is
 a mobile OS developed by the UBports Foundation. Lomiri is its operating
 environment optimized for touch based human-machine interaction, but
 also supports convergence (i.e. switching between tablet/phone and
 desktop mode).
 .
 This package provides Lomiri's Clock App.

## lomiri-clock-app 3.13~git20221230.b2aca5c

=== debian/changelog ===
lomiri-clock-app (3.13~git20221230.b2aca5c-1) unstable; urgency=medium

  * New upstream Git snapshot.
  * debian/patches:
    + Add 1001_reenable-tests.patch,
      0001_tests-unit-tst_alarmSound.qml-Adjust-to-internal-API.patch.
      Fix autopkgtest runs.
    + Add 0002_backend-modules-Alarm-settings.cpp-Use-DBus-interfac.patch.
      Use ayatana-indicator-datetime DBus interface rather than
      Ubuntu's indicator-datetime's.
  * debian/tests:
    + Drop autopilot autopkgtest. Autopilot is not available in Debian.
      (Closes: #1023579).
  * debian/tests/control:
    + Drop qt5-default. Virtual package.
    + Update Depends: field, now this provides all required dependencies for
      running the unit tests as autopkgtest.
  * debian/rules:
    + Drop autopilot test files before running dh_install.

  [ Marius Gripsgard ]
  * debian/control:
    + Add missing runtime dep

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 20 Nov 2022 15:42:05 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCLICK_MODE=OFF

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CTEST_OUTPUT_ON_FAILURE=1 make -C obj-$(DEB_HOST_GNU_TYPE) test
endif

override_dh_install:
	rm debian/lomiri-clock-app/usr/lib/python3 -Rv
	dh_install

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=3.13~git%cd.%h" \
https://gitlab.com/ubports/development/apps/lomiri-clock-app \
HEAD debian uupdate

## lomiri-clock-app 4.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-project(lomiri-clock-app C CXX)
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.5)
+project(lomiri-clock-app VERSION 4.0.0 LANGUAGES CXX)
 
 include(FindPkgConfig)
 
@@ -10,7 +10,6 @@
 find_package(Qt5Qml)
 find_package(Qt5Quick)
 find_package(Qt5DBus)
-#find_package(ubuntu-sdk-libs)
 
 include(FindGettext)
 if(NOT GETTEXT_FOUND)
@@ -109,8 +108,7 @@
 add_subdirectory(app)
 add_subdirectory(backend)
 add_subdirectory(po)
-#Disabling autopilot tests for now due to CI issues
-#add_subdirectory(tests)
+add_subdirectory(tests)
 
 # make the README files visible in qtcreator
 file(GLOB README_FILES

=== debian/changelog ===
lomiri-clock-app (4.0.0-1) unstable; urgency=medium

  * New usptream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/patches:
    + Drop all patches. All applied upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/rules:
    + Drop dh_install override. Not needed anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 30 Jan 2023 22:17:06 +0100

## lomiri-clock-app 4.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.0.0 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.0.1 LANGUAGES CXX)
 
 include(FindPkgConfig)

=== debian/changelog ===
lomiri-clock-app (4.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 11:49:16 +0100

## lomiri-clock-app 4.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.0.1 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.0.2 LANGUAGES CXX)
 
 include(FindPkgConfig)

=== app/CMakeLists.txt ===
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  file(GLOB QML_JS_FILES *.qml *.js *.png *.svg)
  add_custom_target(lomiri-clock-app_QMlFiles ALL SOURCES ${QML_JS_FILES})
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")


if(CLICK_MODE)
  set(ICON ${ICON})
  install(FILES ${ICON} DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES ${SPLASH_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX})
else(CLICK_MODE)
  install(FILES ${ICON_FILE} DESTINATION ${LOMIRI-CLOCK_APP_DIR})
endif(CLICK_MODE)

install(FILES ${MAIN_QML} DESTINATION ${LOMIRI-CLOCK_APP_DIR})
install(FILES "MainPage.qml" DESTINATION ${LOMIRI-CLOCK_APP_DIR})

add_subdirectory(clock)
add_subdirectory(alarm)
add_subdirectory(stopwatch)
add_subdirectory(graphics)
add_subdirectory(components)
add_subdirectory(worldclock)
add_subdirectory(upstreamcomponents)
add_subdirectory(timer)

=== tests/CMakeLists.txt ===
add_subdirectory(unit)

# Disabling autopilot tests for now due to CI issues

#if(NOT CLICK_MODE)
#  add_subdirectory(autopilot)
#endif(NOT CLICK_MODE)

=== app/stopwatch/CMakeLists.txt ===
set(STOPWATCH_QML_JS_FILES
    LapListView.qml
    LapsListDelegate.qml
    StopwatchFace.qml
    StopwatchPage.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_stopwatch_QMlFiles ALL SOURCES ${STOPWATCH_QML_JS_FILES})

install(FILES ${STOPWATCH_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/stopwatch)

=== debian/changelog ===
lomiri-clock-app (4.0.2-1) unstable; urgency=medium

  * New upstream release.
    - Translation updates.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 27 Feb 2023 15:03:35 +0100

=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
          qml-module-qtmultimedia,
          qml-module-qtpositioning,
          qml-module-lomiri-content,
+         qml-module-usermetrics,
          lomiri-sounds,
          suru-icon-theme | ubuntu-mobile-icons,
          ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -17,10 +17,6 @@
 	CTEST_OUTPUT_ON_FAILURE=1 make -C obj-$(DEB_HOST_GNU_TYPE) test
 endif
 
-override_dh_install:
-	rm debian/lomiri-clock-app/usr/lib/python3 -Rv
-	dh_install
-
 override_dh_missing:
 	dh_missing --fail-missing

=== debian/tests/control ===
Tests: make-test
Depends: cmake,
         make,
         libqt5test5,
         libgeonames-dev,
         qml-module-qttest,
         qml-module-lomiri-components,
         qml-module-lomiri-content,
         qml-module-lomiri-test,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qtmultimedia,
         qml-module-u1db,
         qtbase5-dev,
         qtdeclarative5-dev,
         qtdeclarative5-dev-tools,
         xauth,
         xvfb,
Restrictions: build-needed

## lomiri-clock-app 4.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.0.2 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.0.3 LANGUAGES CXX)
 
 include(FindPkgConfig)
 
@@ -85,8 +85,10 @@
   configure_file(${MANIFEST_PATH} ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
   install(FILES "${APP_HARDCODE}.json" DESTINATION ${CMAKE_INSTALL_PREFIX})
-  set(EXEC "qmlscene -I ${MODULE_PATH} %U ${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
+  install(PROGRAMS lomiri-clock-app-migrate.py DESTINATION ${CMAKE_INSTALL_PREFIX})
+  set(EXEC "lomiri-clock-app-migrate.py qmlscene -I ${MODULE_PATH} %U ${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
 else(CLICK_MODE)
+  install(PROGRAMS lomiri-clock-app-migrate.py DESTINATION ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR})
   set(EXEC "qmlscene $@ -I ${MODULE_PATH}  ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
 endif()

=== backend/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

add_definitions(
  -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_LOCALEDIR}\"
  -DQT_NO_KEYWORDS
)

pkg_check_modules(GEONAMES REQUIRED geonames)

set(
    alarm_SRCS
    modules/Alarm/backend.cpp
    modules/Alarm/settings.cpp
    modules/Alarm/sound.cpp
    modules/Alarm/sortedalarmsmodel.cpp
)

set(
    worldclock_SRCS
    modules/WorldClock/backend.cpp
    modules/WorldClock/geolocation.cpp
    modules/WorldClock/datetime.cpp
    modules/WorldClock/timezonemodel.cpp
    modules/WorldClock/generictimezonemodel.cpp
    modules/WorldClock/geonamestimezonemodel.cpp
    modules/WorldClock/statictimezonemodel.cpp
)

set(
    stopwatch_SRCS
    modules/Stopwatch/backend.cpp
    modules/Stopwatch/engine.cpp
    modules/Stopwatch/formattime.cpp
)

set(
    timer_SRCS
    modules/Timer/backend.cpp
    modules/Timer/timerengine.cpp
)

add_library(alarm MODULE
    ${alarm_SRCS}
)

add_library(worldclock MODULE
    ${worldclock_SRCS}
)

add_library(stopwatch MODULE
    ${stopwatch_SRCS}
)

add_library(timer MODULE
    ${timer_SRCS}
)

set_target_properties(alarm PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY Alarm
)

set_target_properties(worldclock PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY WorldClock
)

set_target_properties(stopwatch PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY Stopwatch/
)

set_target_properties(timer PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY Timer/
)

target_link_libraries(alarm PUBLIC Qt5::Gui Qt5::Qml Qt5::Quick Qt5::DBus)

target_include_directories(worldclock PUBLIC ${GEONAMES_INCLUDE_DIRS})
target_link_libraries(worldclock PUBLIC ${GEONAMES_LDFLAGS} Qt5::Gui Qt5::Qml Qt5::Quick)

target_link_libraries(stopwatch PUBLIC Qt5::Qml)

target_link_libraries(timer PUBLIC Qt5::Qml)

# Copy qmldir file to build dir for running in QtCreator
add_custom_target(alarm-qmldir ALL
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Alarm/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Alarm
    DEPENDS ${QMLFILES}
)

add_custom_target(worldclock-qmldir ALL
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/WorldClock/qmldir ${CMAKE_CURRENT_BINARY_DIR}/WorldClock
    DEPENDS ${QMLFILES}
)

add_custom_target(stopwatch-qmldir ALL
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Stopwatch/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Stopwatch
    DEPENDS ${QMLFILES}
)

add_custom_target(timer-qmldir ALL
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Timer/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Timer
    DEPENDS ${QMLFILES}
)

# Install plugin file
install(TARGETS alarm DESTINATION ${MODULE_PATH}/Alarm/)
install(FILES   modules/Alarm/qmldir DESTINATION ${MODULE_PATH}/Alarm/)

install(TARGETS worldclock DESTINATION ${MODULE_PATH}/WorldClock/)
install(FILES   modules/WorldClock/qmldir DESTINATION ${MODULE_PATH}/WorldClock/)

install(TARGETS stopwatch DESTINATION ${MODULE_PATH}/Stopwatch/)
install(FILES   modules/Stopwatch/qmldir DESTINATION ${MODULE_PATH}/Stopwatch/)

install(TARGETS timer DESTINATION ${MODULE_PATH}/Timer/)
install(FILES   modules/Timer/qmldir DESTINATION ${MODULE_PATH}/Timer/)

=== app/components/CMakeLists.txt ===
set(COMPONENTS_QML_JS_FILES
    AlarmBottomEdge.qml
    ActionIcon.qml
    AnalogMode.qml
    AnalogShadow.qml
    Circle.qml
    Clock.qml
    ClockCircle.qml
    DigitalMode.qml
    DigitalShadow.qml
    EmptyState.qml
    ExpandableListItem.qml
    NavigationRow.qml
    Information.qml
    NestedListviewsHack.qml
    Shadow.qml
    AdjustableAnalogClock.qml
    TimerUtils.qml
    BottomSwipeArea.qml
    ClockAppUtils.qml
    ListItemHeader.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_components_QMlFiles ALL SOURCES ${COMPONENTS_QML_JS_FILES})

install(FILES ${COMPONENTS_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/components)

=== app/upstreamcomponents/CMakeLists.txt ===
set(UPSTREAM_COMPONENTS_QML_JS_FILES
    FastScroll.js
    FastScroll.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_upstream_components_QMlFiles ALL SOURCES ${UPSTREAM_COMPONENTS_QML_JS_FILES})

install(FILES ${UPSTREAM_COMPONENTS_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/upstreamcomponents)

=== tests/autopilot/CMakeLists.txt ===
execute_process(COMMAND python3 -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())"
    OUTPUT_VARIABLE PYTHON_PACKAGE_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)

if(INSTALL_TESTS)
    install(DIRECTORY ${AUTOPILOT_DIR}
        DESTINATION ${PYTHON_PACKAGE_DIR}
        )
endif(INSTALL_TESTS)

=== debian/changelog ===
lomiri-clock-app (4.0.3-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:51:44 +1100

lomiri-clock-app (4.0.3-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:44:15 +0000

lomiri-clock-app (4.0.3-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:34:50 +0000

lomiri-clock-app (4.0.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.
    + Update copyright attributions.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/rules:
    + Remove not needed migration script (Ubuntu Touch specific).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 Feb 2024 00:37:02 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lomiri-clock-app
 Section: misc
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake,
@@ -29,7 +30,7 @@
                qml-module-lomiri-test,
                xauth,
                xvfb,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-clock-app
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-clock-app.git

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/apps/lomiri-clock-app/tags .*/lomiri-clock-app-v(\d\S+)\.tar\.gz

## lomiri-clock-app 4.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.0.3 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.0.4 LANGUAGES CXX)
 
 include(FindPkgConfig)
 
@@ -36,7 +36,6 @@
 set(ICON_FILE               clock-app.svg)
 set(SPLASH_FILE             clock-app-splash.svg)
 SET(AUTOPILOT_DIR           lomiri_clock_app)
-set(URLS_FILE               "${CLICK_NAME}_${APP_NAME}.url-dispatcher")
 
 #set install paths
 if(CLICK_MODE)
@@ -61,6 +60,7 @@
         set(SOURCE lp:${APP_HARDCODE})
         message("-- Setting SOURCE to ${SOURCE}")
     endif(NOT SOURCE)
+  set(URLS_FILE               "${CLICK_NAME}_${APP_NAME}.url-dispatcher")
 
 else(CLICK_MODE)
   set(LOMIRI-CLOCK_APP_DIR "${CMAKE_INSTALL_DATADIR}/${APP_HARDCODE}")
@@ -71,6 +71,7 @@
     )
   set(MODULE_PATH ${QT_IMPORTS_DIR}/ClockApp)
   set(ICON ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${ICON_FILE})
+  set(URLS_FILE               "${APP_HARDCODE}.url-dispatcher")
 endif(CLICK_MODE)
 
 if(${CLICK_MODE})
@@ -92,7 +93,9 @@
   set(EXEC "qmlscene $@ -I ${MODULE_PATH}  ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
 endif()
 
-install(FILES ${URLS_FILE} DESTINATION "${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls")
+install(FILES "${APP_HARDCODE}.url-dispatcher"
+        DESTINATION "${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls"
+        RENAME ${URLS_FILE})
 
 configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)

=== debian/changelog ===
lomiri-clock-app (4.0.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 30 Jun 2024 13:36:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-clock-app
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake,
@@ -30,7 +29,7 @@
                qml-module-lomiri-test,
                xauth,
                xvfb,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-clock-app
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-clock-app.git

## lomiri-clock-app 4.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.0.4 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.1.0 LANGUAGES CXX)
 
 include(FindPkgConfig)
 
@@ -23,7 +23,7 @@
 option(CLICK_MODE "Build as a click package" on)
 option(USE_XVFB "Use XVFB to run qml tests" on)
 
-enable_testing()
+include(CTest)
 
 # Standard install paths
 include(GNUInstallDirs)
@@ -38,13 +38,18 @@
 SET(AUTOPILOT_DIR           lomiri_clock_app)
 
 #set install paths
+
 if(CLICK_MODE)
   set(CMAKE_INSTALL_PREFIX "/")
-  set(LOMIRI-CLOCK_APP_DIR    "${CMAKE_INSTALL_DATADIR}/qml")
+endif(CLICK_MODE)
 
+set(LOMIRI-CLOCK_APP_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${APP_HARDCODE}")
+
+if(CLICK_MODE)
   set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}")
-  set(MODULE_PATH ${QT_IMPORTS_DIR})
+  set(MODULE_PATH ${QT_IMPORTS_DIR}/ClockApp)
   set(ICON ${ICON_FILE})
+  set(SPLASH ${SPLASH_FILE})
     if(NOT SOURCE)
         execute_process(
             COMMAND git remote -v
@@ -63,18 +68,18 @@
   set(URLS_FILE               "${CLICK_NAME}_${APP_NAME}.url-dispatcher")
 
 else(CLICK_MODE)
-  set(LOMIRI-CLOCK_APP_DIR "${CMAKE_INSTALL_DATADIR}/${APP_HARDCODE}")
   execute_process(
     COMMAND qmake -query QT_INSTALL_QML
             OUTPUT_VARIABLE QT_IMPORTS_DIR
             OUTPUT_STRIP_TRAILING_WHITESPACE
     )
   set(MODULE_PATH ${QT_IMPORTS_DIR}/ClockApp)
-  set(ICON ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${ICON_FILE})
+  set(ICON ${LOMIRI-CLOCK_APP_DIR}/${ICON_FILE})
+  set(SPLASH ${LOMIRI-CLOCK_APP_DIR}/${SPLASH_FILE})
   set(URLS_FILE               "${APP_HARDCODE}.url-dispatcher")
 endif(CLICK_MODE)
 
-if(${CLICK_MODE})
+if(CLICK_MODE)
   message("-- Configuring manifest.json")
 
   execute_process(
@@ -87,10 +92,11 @@
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${CMAKE_INSTALL_PREFIX})
   install(FILES "${APP_HARDCODE}.json" DESTINATION ${CMAKE_INSTALL_PREFIX})
   install(PROGRAMS lomiri-clock-app-migrate.py DESTINATION ${CMAKE_INSTALL_PREFIX})
-  set(EXEC "lomiri-clock-app-migrate.py qmlscene -I ${MODULE_PATH} %U ${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
+  # Not FULL because under APP_DIR
+  set(EXEC "lomiri-clock-app-migrate.py ${CMAKE_INSTALL_BINDIR}/${APP_HARDCODE}")
 else(CLICK_MODE)
-  install(PROGRAMS lomiri-clock-app-migrate.py DESTINATION ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR})
-  set(EXEC "qmlscene $@ -I ${MODULE_PATH}  ${CMAKE_INSTALL_PREFIX}/${LOMIRI-CLOCK_APP_DIR}/${MAIN_QML}")
+  install(PROGRAMS lomiri-clock-app-migrate.py DESTINATION ${LOMIRI-CLOCK_APP_DIR})
+  set(EXEC "${APP_HARDCODE}")
 endif()
 
 install(FILES "${APP_HARDCODE}.url-dispatcher"
@@ -113,7 +119,10 @@
 add_subdirectory(app)
 add_subdirectory(backend)
 add_subdirectory(po)
-add_subdirectory(tests)
+
+if(BUILD_TESTING)
+  add_subdirectory(tests)
+endif(BUILD_TESTING)
 
 # make the README files visible in qtcreator
 file(GLOB README_FILES
@@ -127,6 +136,6 @@
                     DEPENDS timezone timezone-qmldir alarmsettings alarmsettings-qmldir datetime datetime-qmldir geolocation geolocation-qmldir
                     WORKING_DIRECTORY ./app)
 
-add_custom_target("run" /usr/bin/qmlscene -I ${CMAKE_BINARY_DIR}/backend  ${CMAKE_SOURCE_DIR}/app/lomiri-clock-app.qml
-                    DEPENDS timezone timezone-qmldir alarmsettings alarmsettings-qmldir datetime datetime-qmldir geolocation geolocation-qmldir
+add_custom_target("run" ${APP_HARDCODE} -I ${CMAKE_BINARY_DIR}/backend -q ${CMAKE_SOURCE_DIR}/app/lomiri-clock-app.qml
+                    DEPENDS ${APP_HARDCODE} timezone timezone-qmldir alarmsettings alarmsettings-qmldir datetime datetime-qmldir geolocation geolocation-qmldir
                     WORKING_DIRECTORY ./app)

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,38 @@
 if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
-  file(GLOB QML_JS_FILES *.qml *.js *.png *.svg)
+  file(GLOB_RECURSE QML_JS_FILES *.qml *.js *.png *.svg)
   add_custom_target(lomiri-clock-app_QMlFiles ALL SOURCES ${QML_JS_FILES})
 endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
 
+list(APPEND ${APP_HARDCODE}_SRCS
+  main.cpp
+)
+
+configure_file(config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/config.hpp @ONLY)
+
+list(APPEND ${APP_HARDCODE}_SRCS
+  ${CMAKE_CURRENT_BINARY_DIR}/config.hpp
+)
+
+add_executable(${APP_HARDCODE} ${${APP_HARDCODE}_SRCS})
+
+target_include_directories(${APP_HARDCODE} PRIVATE
+  ${CMAKE_CURRENT_BINARY_DIR}
+)
+
+target_link_libraries(${APP_HARDCODE} PUBLIC
+  Qt5::Core
+  Qt5::Qml
+  Qt5::Quick
+)
+
+install(TARGETS ${APP_HARDCODE} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 if(CLICK_MODE)
-  set(ICON ${ICON})
-  install(FILES ${ICON} DESTINATION ${CMAKE_INSTALL_PREFIX})
+  install(FILES ${ICON_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX})
   install(FILES ${SPLASH_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX})
 else(CLICK_MODE)
   install(FILES ${ICON_FILE} DESTINATION ${LOMIRI-CLOCK_APP_DIR})
+  install(FILES ${SPLASH_FILE} DESTINATION ${LOMIRI-CLOCK_APP_DIR})
 endif(CLICK_MODE)
 
 install(FILES ${MAIN_QML} DESTINATION ${LOMIRI-CLOCK_APP_DIR})

=== backend/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 add_definitions(
   -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
-  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_LOCALEDIR}\"
+  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_FULL_LOCALEDIR}\"
   -DQT_NO_KEYWORDS
 )
 
@@ -59,19 +59,19 @@
 )
 
 set_target_properties(alarm PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY Alarm
+    LIBRARY_OUTPUT_DIRECTORY ClockApp/Alarm
 )
 
 set_target_properties(worldclock PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY WorldClock
+    LIBRARY_OUTPUT_DIRECTORY ClockApp/WorldClock
 )
 
 set_target_properties(stopwatch PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY Stopwatch/
+    LIBRARY_OUTPUT_DIRECTORY ClockApp/Stopwatch
 )
 
 set_target_properties(timer PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY Timer/
+    LIBRARY_OUTPUT_DIRECTORY ClockApp/Timer
 )
 
 target_link_libraries(alarm PUBLIC Qt5::Gui Qt5::Qml Qt5::Quick Qt5::DBus)
@@ -85,22 +85,22 @@
 
 # Copy qmldir file to build dir for running in QtCreator
 add_custom_target(alarm-qmldir ALL
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Alarm/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Alarm
+    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Alarm/qmldir ${CMAKE_CURRENT_BINARY_DIR}/ClockApp/Alarm
     DEPENDS ${QMLFILES}
 )
 
 add_custom_target(worldclock-qmldir ALL
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/WorldClock/qmldir ${CMAKE_CURRENT_BINARY_DIR}/WorldClock
+    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/WorldClock/qmldir ${CMAKE_CURRENT_BINARY_DIR}/ClockApp/WorldClock
     DEPENDS ${QMLFILES}
 )
 
 add_custom_target(stopwatch-qmldir ALL
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Stopwatch/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Stopwatch
+    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Stopwatch/qmldir ${CMAKE_CURRENT_BINARY_DIR}/ClockApp/Stopwatch
     DEPENDS ${QMLFILES}
 )
 
 add_custom_target(timer-qmldir ALL
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Timer/qmldir ${CMAKE_CURRENT_BINARY_DIR}/Timer
+    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Timer/qmldir ${CMAKE_CURRENT_BINARY_DIR}/ClockApp/Timer
     DEPENDS ${QMLFILES}
 )

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

add_custom_target(${POT_FILE} ALL
    COMMENT "Generating translation template..."
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
        --from-code=UTF-8
        --language=Desktop
        --package-name='${PROJECT_NAME}'
        -D ${CMAKE_BINARY_DIR}
        ${DESKTOP_FILE}.in
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
        -D ${CMAKE_SOURCE_DIR}
        -D ${CMAKE_CURRENT_SOURCE_DIR}
        -D ${CMAKE_CURRENT_BINARY_DIR}
        --from-code=UTF-8
        --c++ --qt --add-comments=TRANSLATORS
        --keyword=tr --keyword=tr:1,2 --keyword=N_ --keyword=_ --keyword=tag --keyword=tag:1c,2
        --package-name='${PROJECT_NAME}'
        --copyright-holder='Canonical Ltd.'
        --join-existing
        --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES
)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY
    )
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS}
)

=== app/worldclock/CMakeLists.txt ===
set(WORLDCLOCK_QML_JS_FILES
    AddWorldCityButton.qml
    UserWorldCityDelegate.qml
    UserWorldCityList.qml
    WorldCityList.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_worldclock_QMlFiles ALL SOURCES ${WORLDCLOCK_QML_JS_FILES})

install(FILES ${WORLDCLOCK_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/worldclock)

=== tests/unit/CMakeLists.txt ===
find_program(QMLTESTRUNNER_BIN
    NAMES qmltestrunner
    PATHS /usr/lib/*/qt5/bin
)

if(NOT QMLTESTRUNNER_BIN)
    message(FATAL_ERROR "qmltestrunner not found")
endif(NOT QMLTESTRUNNER_BIN)

if(USE_XVFB)
    find_program(XVFB_RUN_BIN
        NAMES xvfb-run
    )

    if(NOT XVFB_RUN_BIN)
        message(FATAL_ERROR "xvfb-run not found")
    endif(NOT XVFB_RUN_BIN)
endif(USE_XVFB)

macro(DECLARE_QML_TEST TST_NAME TST_QML_FILE)
    if(USE_XVFB)
        set(COMMAND_PREFIX ${XVFB_RUN_BIN} -a -s "-screen 0 400x600x24")
    else()
        set(COMMAND_PREFIX "")
    endif()
    add_test(NAME ${TST_NAME}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMAND env TZ=UTC ${COMMAND_PREFIX} ${QMLTESTRUNNER_BIN} -import ${CMAKE_BINARY_DIR}/backend -input ${CMAKE_CURRENT_SOURCE_DIR}/${TST_QML_FILE}
    )
endmacro()

declare_qml_test("AlarmLabel" tst_alarmLabel.qml)
declare_qml_test("AlarmRepeat" tst_alarmRepeat.qml)
declare_qml_test("Alarm" tst_alarm.qml)
declare_qml_test("AlarmSound" tst_alarmSound.qml)
declare_qml_test("AlarmUtils" tst_alarmUtils.qml)
#declare_qml_test("WorldClock" tst_worldClock.qml) FIXME: BROKEN!!!
declare_qml_test("StopwatchUtils" tst_stopwatchUtils.qml)

set(QML_TST_FILES
    tst_alarmLabel.qml
    tst_alarmRepeat.qml
    tst_alarm.qml
    tst_alarmSound.qml
    tst_alarmUtils.qml
#    tst_worldClock.qml FIXME! BROKEN TEST!!
    tst_stopwatchUtils.qml
)
add_custom_target(tst_QmlFiles ALL SOURCES ${QML_TST_FILES})

set(QML_TST_UTILS
    MockClockApp.qml
    ClockTestCase.qml
)

add_custom_target(tst_Utils ALL SOURCES ${QML_TST_UTILS})

=== debian/changelog ===
lomiri-clock-app (4.1.0-3) unstable; urgency=medium

  * debian/tests:
    + Drop autopkgtest config. Unit tests run at build-time now. (Closes:
      #1093040).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 15 Jan 2025 11:00:16 +0100

lomiri-clock-app (4.1.0-2) unstable; urgency=medium

  * debian/patches:
    + Add 2001_disable-splash-screen.patch. Hide splash screen to work-around
      awkward positioning of the Clock App which makes it impossible to reach
      the app's top window bar.
    + Add 2002_hide-on-other-desktops.patch. Hide Lomiri's Clock App on
      non-Lomiri DEs.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 08 Jan 2025 09:13:07 +0100

lomiri-clock-app (4.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Drop from D: qmlscene.
    + Add to B-D: pkgconf.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 04 Nov 2024 13:35:19 +0100

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
                libgeonames-dev,
                lomiri-sounds,
                suru-icon-theme,
+               pkgconf,
                qml-module-qttest,
                qml-module-qtsysteminfo,
                qml-module-qt-labs-settings,
@@ -37,8 +38,7 @@
 
 Package: lomiri-clock-app
 Architecture: any
-Depends: qmlscene,
-         qml-module-u1db,
+Depends: qml-module-u1db,
          qml-module-lomiri-components,
          qml-module-lomiri-layouts,
          qml-module-qtquick-xmllistmodel,

## lomiri-clock-app 4.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-clock-app VERSION 4.1.0 LANGUAGES CXX)
+project(lomiri-clock-app VERSION 4.1.1 LANGUAGES CXX)
 
 include(FindPkgConfig)
 
@@ -10,6 +10,7 @@
 find_package(Qt5Qml)
 find_package(Qt5Quick)
 find_package(Qt5DBus)
+find_package(Intl REQUIRED)
 
 include(FindGettext)
 if(NOT GETTEXT_FOUND)

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
   Qt5::Core
   Qt5::Qml
   Qt5::Quick
+  ${Intl_LIBRARIES}
 )
 
 install(TARGETS ${APP_HARDCODE} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== backend/CMakeLists.txt ===
--- 
+++ 
@@ -36,12 +36,6 @@
     modules/Stopwatch/formattime.cpp
 )
 
-set(
-    timer_SRCS
-    modules/Timer/backend.cpp
-    modules/Timer/timerengine.cpp
-)
-
 add_library(alarm MODULE
     ${alarm_SRCS}
 )
@@ -52,10 +46,6 @@
 
 add_library(stopwatch MODULE
     ${stopwatch_SRCS}
-)
-
-add_library(timer MODULE
-    ${timer_SRCS}
 )
 
 set_target_properties(alarm PROPERTIES
@@ -70,18 +60,12 @@
     LIBRARY_OUTPUT_DIRECTORY ClockApp/Stopwatch
 )
 
-set_target_properties(timer PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY ClockApp/Timer
-)
-
 target_link_libraries(alarm PUBLIC Qt5::Gui Qt5::Qml Qt5::Quick Qt5::DBus)
 
 target_include_directories(worldclock PUBLIC ${GEONAMES_INCLUDE_DIRS})
 target_link_libraries(worldclock PUBLIC ${GEONAMES_LDFLAGS} Qt5::Gui Qt5::Qml Qt5::Quick)
 
 target_link_libraries(stopwatch PUBLIC Qt5::Qml)
-
-target_link_libraries(timer PUBLIC Qt5::Qml)
 
 # Copy qmldir file to build dir for running in QtCreator
 add_custom_target(alarm-qmldir ALL
@@ -99,11 +83,6 @@
     DEPENDS ${QMLFILES}
 )
 
-add_custom_target(timer-qmldir ALL
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/modules/Timer/qmldir ${CMAKE_CURRENT_BINARY_DIR}/ClockApp/Timer
-    DEPENDS ${QMLFILES}
-)
-
 # Install plugin file
 install(TARGETS alarm DESTINATION ${MODULE_PATH}/Alarm/)
 install(FILES   modules/Alarm/qmldir DESTINATION ${MODULE_PATH}/Alarm/)
@@ -113,6 +92,3 @@
 
 install(TARGETS stopwatch DESTINATION ${MODULE_PATH}/Stopwatch/)
 install(FILES   modules/Stopwatch/qmldir DESTINATION ${MODULE_PATH}/Stopwatch/)
-
-install(TARGETS timer DESTINATION ${MODULE_PATH}/Timer/)
-install(FILES   modules/Timer/qmldir DESTINATION ${MODULE_PATH}/Timer/)

=== app/alarm/CMakeLists.txt ===
set(ALARM_QML_JS_FILES
    AlarmDelegate.qml
    AlarmLabel.qml
    AlarmList.qml
    AlarmModelComponent.qml
    AlarmPage.qml
    AlarmRepeat.qml
    AlarmSettingsPage.qml
    AlarmSound.qml
    AlarmUtils.qml
    EditAlarmPage.qml
    SoundPeerPicker.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_alarm_QMlFiles ALL SOURCES ${ALARM_QML_JS_FILES})

install(FILES ${ALARM_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/alarm)

=== app/clock/CMakeLists.txt ===
set(CLOCK_QML_JS_FILES
    ClockPage.qml
    MainClock.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_clock_QMlFiles ALL SOURCES ${CLOCK_QML_JS_FILES})

install(FILES ${CLOCK_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/clock)

=== app/graphics/CMakeLists.txt ===
set(GRAPHICS_FILES
    Hour_Hand@27.png
    Hour_Hand_Shadow@27.png
    Inner_Clock_Texture@27.png
    Knob@27.png
    Minute_Hand@27.png
    Minute_Hand_White@27.png
    Minute_Hand_Shadow@27.png
    Second_Hand@27.png
    Second_Hand_Shadow@27.png
    Hour_Adjust_Circle@27.png
    Minute_Adjust_Cirlce@27.png
    Minute_Adjust_Cirlce_White@27.png
)

# make the files visible in the qtcreator tree
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  add_custom_target(lomiri-clock-app_graphics_PNGFiles ALL SOURCES ${GRAPHICS_FILES})
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

install(FILES ${GRAPHICS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/graphics)

=== app/timer/CMakeLists.txt ===
set(TIMER_QML_JS_FILES
    TimerFace.qml
    TimerPage.qml
    TimerListDelegate.qml
    TimerListView.qml
    ActiveTimers.qml
)

# make the files visible in the qtcreator tree
add_custom_target(lomiri-clock-app_timer_QMlFiles ALL SOURCES ${TIMER_QML_JS_FILES})

install(FILES ${TIMER_QML_JS_FILES} DESTINATION ${LOMIRI-CLOCK_APP_DIR}/timer)

=== tests/unit/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 find_program(QMLTESTRUNNER_BIN
     NAMES qmltestrunner
-    PATHS /usr/lib/*/qt5/bin
+    PATHS /usr/lib/qt5/bin /usr/lib/*/qt5/bin
 )
 
 if(NOT QMLTESTRUNNER_BIN)

=== debian/changelog ===
lomiri-clock-app (4.1.1-2) unstable; urgency=medium

  * debian/patches:
    + Add 0001_update-enum-to-typo-fix-in-LUITK.patch. Use correct enum
      according to LUITK Alarm typo fix fixes.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 24 Jul 2025 08:04:53 +0200

lomiri-clock-app (4.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/lintian-overrides:
    + Drop file. Not needed anymore.
  * debian/patches:
    + Add header to 2002_hide-on-other-desktops.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 14:30:21 +0200

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
                qml-module-lomiri-test,
                xauth,
                xvfb,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-clock-app
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-clock-app.git

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,10 @@
 	CTEST_OUTPUT_ON_FAILURE=1 make -C obj-$(DEB_HOST_GNU_TYPE) test
 endif
 
+override_dh_install:
+	rm debian/lomiri-clock-app/usr/share/lomiri-clock-app/lomiri-clock-app-migrate.py
+	dh_install
+
 override_dh_missing:
 	dh_missing --fail-missing
